package cz.cvut.kbss.reporting.model;

import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import java.time.LocalDateTime;
import java.util.List;

@Getter
@Setter
@Entity
public class Occurrence extends Event {

    @Basic(optional = false)
    @Column(nullable = false)
    private String name;

    @Basic(optional = false)
    @Column(nullable = false)
    private LocalDateTime startTime;

    @Basic(optional = false)
    @Column(nullable = false)
    private LocalDateTime endTime;


    @Enumerated(EnumType.STRING)    // Use an enum for demonstration purposes
    @Basic(optional = false)
    @Column(nullable = false)
    private Severity severity;

    @OrderBy("type")
    private List<Event> parts;  // Subevents of the occurrence

    @Override
    public String toString() {
        return "Occurrence{" + name +
                "<" + startTime +
                " - " + endTime +
                ">, severity=" + severity +
                ", type=" + getType() +
                "}";
    }
}
