package cz.cvut.kbss.reporting.model;

import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import java.time.LocalDateTime;

@Getter
@Setter
@Entity
@NamedQueries({@NamedQuery(name = "OccurrenceReport.findAll",
                           query = "SELECT r FROM OccurrenceReport r ORDER BY r.occurrence.startTime DESC")})
public class OccurrenceReport extends AbstractEntity {

    @JoinColumn(nullable = false)
    @OneToOne(optional = false, cascade = CascadeType.ALL, fetch = FetchType.EAGER)
    private Occurrence occurrence;

    @JoinColumn(nullable = false, name = "AUTHOR_ID")
    @ManyToOne(optional = false, fetch = FetchType.EAGER)
    private Person author;

    @Basic(optional = false)
    @Column(nullable = false)
    private LocalDateTime created;

    @JoinColumn(name = "LAST_EDITOR_ID")
    @ManyToOne(fetch = FetchType.EAGER)
    private Person lastEditor;

    private LocalDateTime lastModified;

    private String narrative;

    @Override
    public String toString() {
        return "OccurrenceReport{" +
                "occurrence=" + occurrence +
                ", author=" + author +
                "}";
    }
}
