package cz.cvut.kbss.reporting.service.data;

import cz.cvut.kbss.reporting.model.Severity;
import org.springframework.stereotype.Service;

import javax.annotation.PostConstruct;
import java.util.HashMap;
import java.util.Map;

@Service("internalDataLoader")
public class InternalDataLoader implements DataLoader {

    private final Map<String, String> data = new HashMap<>();

    @PostConstruct
    private void initData() {
        data.put(Severity.getOptionType(), Severity.toJson());
    }

    @Override
    public String loadData(String source, Map<String, String> params) {
        if (!data.containsKey(source)) {
            throw new IllegalArgumentException("Internal loader does not contain data from " + source + ".");
        }
        return data.get(source);
    }
}
